Description

When creating host groups with puppet classes or similar, AR doesn't supply the correct field name in the pluck when joining tables:

2.0.0p0 :020 >   Hostgroup.first.puppetclass_ids

Hostgroup Load (39.7ms)  SELECT `hostgroups`.* FROM `hostgroups` WHERE (1=1) LIMIT 1

(37.6ms)  SELECT id FROM `puppetclasses` INNER JOIN `hostgroup_classes` ON `hostgroup_classes`.`puppetclass_id` =

`puppetclasses`.`id` INNER JOIN `hostgroups` ON `hostgroups`.`id` = `hostgroup_classes`.`hostgroup_id` WHERE `hostgroups`.`id`

IN (1)

ActiveRecord::StatementInvalid: Mysql::Error: Column 'id' in field list is ambiguous: SELECT id FROM `puppetclasses` INNER JOIN

`hostgroup_classes` ON `hostgroup_classes`.`puppetclass_id` = `puppetclasses`.`id` INNER JOIN `hostgroups` ON `hostgroups`.`id`

= `hostgroup_classes`.`hostgroup_id` WHERE `hostgroups`.`id` IN (1)

This is only in 3.2.8 (RPMs), not 3.2.13 (source).  Looks like: https://github.com/rails/rails/issues/5990

Related issues:

Related to Foreman - Bug #3122: when fact filters are added to a user, error ... Closed 09/19/2013

Related to Foreman - Bug #3863: when fact filters are added to a user, error ... Resolved 09/19/2013

Associated revisions

Revision 65f764d6 - 05/29/2013 09:42 AM - Dominic Cleal

fixes #2579 - explicitly list field name, workaround rails #5990

Revision 0ad33a98 - 05/29/2013 11:24 AM - Dominic Cleal

fixes #2579 - explicitly list field name, workaround rails #5990

(cherry picked from commit 65f764d6081b04cd03fa56a78e6281b5221b0bac)

History

#1 - 05/28/2013 01:48 PM - Dominic Cleal

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/661

#2 - 05/29/2013 10:17 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 65f764d6081b04cd03fa56a78e6281b5221b0bac.

#3 - 01/02/2014 03:13 PM - Dominic Cleal

- Related to Bug #3122: when fact filters are added to a user, error column reference "id" is ambiguous for dashboard and fact_values added

#4 - 01/02/2014 03:13 PM - Dominic Cleal
https://github.com/rails/rails/issues/5990
https://github.com/theforeman/foreman/pull/661
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/65f764d6081b04cd03fa56a78e6281b5221b0bac


- Related to Bug #3863: when fact filters are added to a user, error column reference "id" is ambiguous for fact_values added
